local mReady = false

AddEventHandler('onMySQLReady', function ()
	mReady = true
end)

AddEventHandler('es_db:firstRunCheck', function(ip, port)
	-- Not in use
end)

AddEventHandler('es_db:doesUserExist', function(identifier, callback)
	MySQL.Async.fetchAll('SELECT * FROM vrp_user_ids WHERE `identifier`=@identifier;', {identifier = identifier}, function(user_id)
		if user_id[1] then
			callback(true)
		else
			callback(false)
		end	
	end)
end)

AddEventHandler('es_db:retrieveUser', function(identifier, callback)
	local Callback = callback
	MySQL.Async.fetchAll('SELECT * FROM vrp_user_ids WHERE `identifier`=@identifier;', {identifier = identifier}, function(user_id)
		if user_id[1] then
			Callback(user_id[1])
		else
			Callback(false)
		end
	end)
end)

AddEventHandler('es_db:createUser', function(identifier, callback)
	local user = { identifier = identifier }

	MySQL.Async.execute('INSERT INTO vrp_user_ids (`identifier`) VALUE (@identifier);', {identifier = user_id.identifier}, function(e)
		callback()
	end)
end)

AddEventHandler('es_db:createUser', function(license, callback)
	local user = { license = license }

	MySQL.Async.execute('INSERT INTO vrp_user_ids (`license`) VALUE (@license);', {license = user.license}, function(e)
		callback()	
	end)
end)

AddEventHandler('es_db:createUser', function(cash, callback)
	local user = { wallet = cash or 0 }

	MySQL.Async.execute('INSERT INTO vrp_user_moneys (`wallet`) VALUE (@wallet);', {wallet = user.wallet}, function(e)
		callback()	
	end)
end)

AddEventHandler('es_db:createUser', function(bank, callback)
	local user = { bank = bank or 0 }

	MySQL.Async.execute('INSERT INTO vrp_user_moneys (`bank`) VALUE (@bank);', {bank = user.bank}, function(e)
		callback()	
	end)
end)

AddEventHandler('es_db:createUser', function(groups, callback)
	local user = { groups = "user" }

	MySQL.Async.execute('INSERT INTO vrp_user_ids (`group`) VALUE (@group);', {group = user.group}, function(e)
		callback()	
	end)
end)

AddEventHandler('es_db:createUser', function(permissions_level, callback)
	local user = { permissions_level = 0 }

	MySQL.Async.execute('INSERT INTO vrp_user_ids (`permissions_level`) VALUE (@permissions_level`);', {permission_level = user.permission_level}, function(e)
		callback()	
	end)
end)



AddEventHandler('es_db:retrieveLicensedUser', function(license, callback)
	MySQL.Async.fetchAll('SELECT * FROM vrp_user_ids WHERE `license`=@license;', {license = license}, function(users)
		if users[1] then
			callback(users[1])
		else
			callback(false)
		end
	end)
end)

AddEventHandler('es_db:doesLicensedUserExist', function(license, callback)
	MySQL.Async.fetchAll('SELECT * FROM vrp_user_ids WHERE `license`=@license;', {license = license}, function(users)
		if users[1] then
			callback(true)
		else
			callback(false)
		end
	end)
end)

AddEventHandler('es_db:updateUser', function(identifier, new, callback)
	Citizen.CreateThread(function()
		local updateString = ""

		local length = tLength(new)
		local cLength = 1
		for k,v in pairs(new)do
			if cLength < length then
				if(type(v) == "number")then
					updateString = updateString .. "`" .. k .. "`=" .. v .. ","
				else
					updateString = updateString .. "`" .. k .. "`='" .. v .. "',"
				end
			else
				if(type(v) == "number")then
					updateString = updateString .. "`" .. k .. "`=" .. v .. ""
				else
					updateString = updateString .. "`" .. k .. "`='" .. v .. "'"
				end
			end
			cLength = cLength + 1
		end

		MySQL.Async.execute('UPDATE vrp_user_ids SET ' .. updateString .. ' WHERE `identifier`=@identifier', {identifier = identifier}, function(done)
			if callback then
				callback(true)
			end
		end)
	end)
end)

function tLength(t)
	local l = 0
	for k,v in pairs(t)do
		l = l + 1
	end

	return l
end